## python-escript 5.5

=== SConstruct ===
##############################################################################
#
# Copyright (c) 2003-2018 by The University of Queensland
# http://www.uq.edu.au
#
# Primary Business: Queensland, Australia
# Licensed under the Apache License, version 2.0
# http://www.apache.org/licenses/LICENSE-2.0
#
# Development until 2012 by Earth Systems Science Computational Center (ESSCC)
# Development 2012-2013 by School of Earth Sciences
# Development from 2014 by Centre for Geoscience Computing (GeoComp)
#
##############################################################################

EnsureSConsVersion(0,98,1)
EnsurePythonVersion(2,5)

import atexit, sys, os, platform, re
from distutils import sysconfig
from dependencies import *
from site_init import *

print(sys.version)

# Version number to check for in options file. Increment when new features are
# added or existing options changed.
REQUIRED_OPTS_VERSION=203

# MS Windows support, many thanks to PH
IS_WINDOWS = (os.name == 'nt')

IS_OSX = (os.uname()[0] == 'Darwin')

########################## Determine options file ############################
# 1. command line
# 2. scons/<hostname>_options.py
# 3. name as part of a cluster
options_file=ARGUMENTS.get('options_file', None)
if not options_file:
    ext_dir = os.path.join(os.getcwd(), 'scons')
    hostname = platform.node().split('.')[0]
    for name in hostname, effectiveName(hostname):
        mangledhostname = re.sub('[^0-9a-zA-Z]', '_', hostname)
        options_file = os.path.join(ext_dir, mangledhostname+'_options.py')
        if os.path.isfile(options_file): break

if not os.path.isfile(options_file):
    print("\nWARNING:\nOptions file %s" % options_file)
    print("not found! Default options will be used which is most likely suboptimal.")
    print("We recommend that you copy the most relavent options file in the scons/template/")
    print("subdirectory and customize it to your needs.\n")
    options_file = None

############################### Build options ################################

default_prefix='/usr'
mpi_flavours=('no', 'none', 'MPT', 'MPICH', 'MPICH2', 'OPENMPI', 'INTELMPI')
netcdf_flavours = ('no', 'off', 'none', 'False', # Must be last of the false alternatives
                   'yes', 'on', 'True', '3', # Must be last of the version 3 alternatives
                   '4')
all_domains = ['dudley','finley','ripley','speckley']

#Note that scons construction vars the the following purposes:
#  CPPFLAGS -> to the preprocessor
#  CCFLAGS  -> flags for _both_ C and C++
#  CXXFLAGS -> flags for c++ _only_
#  CFLAGS   -> flags for c only

vars = Variables(options_file, ARGUMENTS)
vars.AddVariables(
  PathVariable('options_file', 'Path to options file', options_file, PathVariable.PathIsFile),
  PathVariable('prefix', 'Installation prefix', Dir('#.').abspath, PathVariable.PathIsDirCreate),
  PathVariable('build_dir', 'Top-level build directory', Dir('#/build').abspath, PathVariable.PathIsDirCreate),
  BoolVariable('verbose', 'Output full compile/link lines', False),
# Compiler/Linker options
  ('cxx', 'Path to C++ compiler', 'default'),
  ('cc_flags', 'Base (C and C++) compiler flags', 'default'),
  ('cc_optim', 'Additional (C and C++) flags for a non-debug build', 'default'),
  ('cc_debug', 'Additional (C and C++) flags for a debug build', 'default'),
  ('cxx_extra', 'Extra C++ compiler flags', ''),
  ('ld_extra', 'Extra linker flags', ''),
  BoolVariable('werror','Treat compiler warnings as errors', True),
  BoolVariable('debug', 'Compile with debug flags', False),
  BoolVariable('openmp', 'Compile parallel version using OpenMP', False),
  ('omp_flags', 'OpenMP compiler flags', 'default'),
  ('omp_ldflags', 'OpenMP linker flags', 'default'),
# Mandatory libraries
  ('boost_prefix', 'Prefix/Paths of boost installation', default_prefix),
  ('boost_libs', 'Boost libraries to link with', ['boost_python-mt']),
# Mandatory for tests
  ('cppunit_prefix', 'Prefix/Paths of CppUnit installation', default_prefix),
  ('cppunit_libs', 'CppUnit libraries to link with', ['cppunit']),
# Optional libraries and options
  EnumVariable('mpi', 'Compile parallel version using MPI flavour', 'none', allowed_values=mpi_flavours),
  ('mpi_prefix', 'Prefix/Paths of MPI installation', default_prefix),
  ('mpi_libs', 'MPI shared libraries to link with', ['mpi']),
  BoolVariable('use_gmsh', 'Enable gmsh, if available', True),
  EnumVariable('netcdf', 'Enable netCDF file support', False, allowed_values=netcdf_flavours),
  ('netcdf_prefix', 'Prefix/Paths of netCDF installation', default_prefix),
  ('netcdf_libs', 'netCDF libraries to link with', 'DEFAULT'),
  BoolVariable('parmetis', 'Enable ParMETIS (requires MPI)', False),
  ('parmetis_prefix', 'Prefix/Paths of ParMETIS installation', default_prefix),
  ('parmetis_libs', 'ParMETIS libraries to link with', ['parmetis', 'metis']),
  BoolVariable('mkl', 'Enable the Math Kernel Library', False),
  ('mkl_prefix', 'Prefix/Paths to MKL installation', default_prefix),
  ('mkl_libs', 'MKL libraries to link with', ['mkl_solver','mkl_em64t','guide','pthread']),
  BoolVariable('umfpack', 'Enable UMFPACK', False),
  ('umfpack_prefix', 'Prefix/Paths to UMFPACK installation', default_prefix),
  ('umfpack_libs', 'UMFPACK libraries to link with', ['umfpack']),
  TristateVariable('lapack', 'Enable LAPACK', 'auto'),
  ('lapack_prefix', 'Prefix/Paths to LAPACK installation', default_prefix),
  ('lapack_libs', 'LAPACK libraries to link with', []),
  BoolVariable('silo', 'Enable the Silo file format in weipa', False),
  ('silo_prefix', 'Prefix/Paths to Silo installation', default_prefix),
  ('silo_libs', 'Silo libraries to link with', ['siloh5', 'hdf5']),
  BoolVariable('trilinos', 'Enable the Trilinos solvers', False),
  ('trilinos_prefix', 'Prefix/Paths to Trilinos installation', default_prefix),
  ('trilinos_libs', 'Trilinos libraries to link with', []),
  BoolVariable('visit', 'Enable the VisIt simulation interface', False),
  ('visit_prefix', 'Prefix/Paths to VisIt installation', default_prefix),
  ('visit_libs', 'VisIt libraries to link with', ['simV2']),
  ListVariable('domains', 'Which domains to build', 'all', all_domains),
  BoolVariable('paso', 'Build Paso solver library', True),
  BoolVariable('weipa', 'Build Weipa data export library', True),
  ('mathjax_path', 'Path to MathJax.js file', 'default'),
# Advanced settings
  ('launcher', 'Launcher command (e.g. mpirun)', 'default'),
  ('prelaunch', 'Command to execute before launcher (e.g. mpdboot)', 'default'),
  ('postlaunch', 'Command to execute after launcher (e.g. mpdexit)', 'default'),
  #dudley_assemble_flags = -funroll-loops      to actually do something
  ('dudley_assemble_flags', 'compiler flags for some dudley optimisations', ''),
  # To enable passing function pointers through python
  BoolVariable('iknowwhatimdoing', 'Allow non-standard C', False),
  # An option for specifying the compiler tools
  ('tools_names', 'Compiler tools to use', ['default']),
  ('env_export', 'Environment variables to be passed to tools',[]),
  TristateVariable('forcelazy', 'For testing use only - set the default value for autolazy', 'auto'),
  TristateVariable('forcecollres', 'For testing use only - set the default value for force resolving collective ops', 'auto'),
  BoolVariable('build_shared', '(deprecated option, ignored)', True),
  ('sys_libs', 'Extra libraries to link with', []),
  ('escript_opts_version', 'Version of options file (do not specify on command line)'),
  ('SVN_VERSION', 'Do not use from options file', -2),
  ('pythoncmd', 'which python to compile with', sys.executable),
  ('pythonlibname', 'Name of the python library to link. (This is found automatically for python2.X.)', ''),
  ('pythonlibpath', 'Path to the python library. (You should not need to set this unless your python has moved)',''),
  ('pythonincpath','Path to python include files. (You should not need to set this unless your python has moved',''),
  BoolVariable('longindices', 'use long indices (for very large matrices)', False),
  BoolVariable('compressed_files','Enables reading from compressed binary files', True),
  ('compression_libs', 'Compression libraries to link with', ['boost_iostreams']),
  BoolVariable('disable_boost_numpy', 'Do not build using boost_numpy, even if it is available', False),
  BoolVariable('osx_dependency_fix', 'Fix dependencies for libraries to have absolute paths (OSX)', False),
  BoolVariable('stdlocationisprefix', 'Set the prefix as escript root in the launcher', False),
  BoolVariable('mpi_no_host', 'Do not specify --host in run-escript launcher (only OPENMPI)', False),
  BoolVariable('insane', 'Instructs scons to not run a sanity check after compilation.', False)
)

##################### Create environment and help text #######################

# Intel's compiler uses regular expressions improperly and emits a warning
# about failing to find the compilers. This warning can be safely ignored.

# PATH is needed so the compiler, linker and tools are found if they are not
# in default locations.
env = Environment(tools = ['default'], options = vars,
                  ENV = {'PATH': os.environ['PATH']})

# set the vars for clang
def mkclang(env):
    env['CXX']='clang++'

if env['tools_names'] != ['default']:
    zz=env['tools_names']
    if 'clang' in zz:
        zz.remove('clang')
        zz.insert(0, mkclang)
    env = Environment(tools = ['default'] + env['tools_names'], options = vars,
                      ENV = {'PATH' : os.environ['PATH']})

# Covert env['netcdf'] into one of False, 3, 4
# Also choose default values for libraries
pos1=netcdf_flavours.index('False')
pos2=netcdf_flavours.index('3')
mypos=netcdf_flavours.index(env['netcdf'])
if 0 <= mypos <=pos1:
    env['netcdf']=0
elif pos1 < mypos <= pos2:
    env['netcdf']=3
    if env['netcdf_libs']=='DEFAULT':
        env['netcdf_libs']=['netcdf_c++', 'netcdf']
else:   # netcdf4
    env['netcdf']=4
    if env['netcdf_libs']=='DEFAULT':
        env['netcdf_libs']=['netcdf_c++4']

if options_file:
    opts_valid=False
    if 'escript_opts_version' in env.Dictionary() and \
        int(env['escript_opts_version']) >= REQUIRED_OPTS_VERSION:
            opts_valid=True
    if opts_valid:
        print("Using options in %s." % options_file)
    else:
        print("\nOptions file %s" % options_file)
        print("is outdated! Please update the file after reading scons/templates/README_FIRST")
        print("and setting escript_opts_version to %d.\n"%REQUIRED_OPTS_VERSION)
        Exit(1)

# Generate help text (scons -h)
Help(vars.GenerateHelpText(env))

# Check for superfluous options
if len(vars.UnknownVariables())>0:
    for k in vars.UnknownVariables():
        print("Unknown option '%s'" % k)
    Exit(1)

if 'dudley' in env['domains']:
    env['domains'].append('finley')

env['domains'] = sorted(set(env['domains']))

# create dictionary which will be populated with info for buildvars file
env['buildvars'] = {}
# create list which will be populated with warnings if there are any
env['warnings'] = []

#################### Make sure install directories exist #####################

env['BUILD_DIR'] = Dir(env['build_dir']).abspath
prefix = Dir(env['prefix']).abspath
env['buildvars']['prefix'] = prefix
env['incinstall'] = os.path.join(prefix, 'include')
env['bininstall'] = os.path.join(prefix, 'bin')
env['libinstall'] = os.path.join(prefix, 'lib')
env['pyinstall']  = os.path.join(prefix, 'esys')
if not os.path.isdir(env['bininstall']):
    os.makedirs(env['bininstall'])
if not os.path.isdir(env['libinstall']):
    os.makedirs(env['libinstall'])
if not os.path.isdir(env['pyinstall']):
    os.makedirs(env['pyinstall'])

env.Append(CPPPATH = [env['incinstall']])
env.Append(LIBPATH = [env['libinstall']])

################# Fill in compiler options if not set above ##################

if env['cxx'] != 'default':
    env['CXX'] = env['cxx']

# default compiler/linker options
cc_flags = '-std=c++11'
cc_optim = ''
cc_debug = ''
omp_flags = ''

=== cusplibrary/examples/SConstruct ===
import os
import inspect
import glob

# try to import an environment first
try:
  Import('env')
except:
  exec open("../build/build-env.py")
  env = Environment()

# find all .cus & .cpps in the current directory
sources = []
directories = [name for name in os.listdir('.') if os.path.isdir(name)]
extensions = ['*.cu', '*.cpp']
for dir in directories:
  if dir == 'OpenGL' : continue
  for ext in extensions:
    regexp = os.path.join(dir, ext)
    #sources.extend(env.Glob(regexp, strings = True))
    sources.extend(glob.glob(regexp))

# compile examples
for src in sources:
  env.Program(src)

=== doc/sphinx_api/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/esys.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/esys.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/esys"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/esys"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== cusplibrary/performance/solver/SConstruct ===
import os
import inspect
import glob

# try to import an environment first
try:
  Import('env')
except:
  exec open("../../build/build-env.py")
  env = Environment()

# on mac we have to tell the linker to link against the C++ library
if env['PLATFORM'] == "darwin":
  env.Append(LINKFLAGS = "-lstdc++")

# find all .cus & .cpps in the current directory
sources = []
directories = ['.']
extensions = ['*.cu', '*.cpp']
for dir in directories:
  for ext in extensions:
    regexp = os.path.join(dir, ext)
    #sources.extend(env.Glob(regexp, strings = True))
    sources.extend(glob.glob(regexp))

# compile examples
for src in sources:
  env.Program(src)

=== debian/changelog ===
python-escript (5.5-5) unstable; urgency=medium

  * Update py3 patch for python3.8 as default
  * Fix boost library version detection in d/sid_options.py
  * Disable boost_numpy detection - it crashes scons

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Mar 2020 20:49:39 +0000

python-escript (5.5-4) unstable; urgency=medium

  * Ensure -mxgot is used on mips64el to enable linking against boost_python

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 24 Feb 2020 09:12:01 +0000

python-escript (5.5-3) unstable; urgency=medium

  * Set -O0 on mips64el builds. Closes: #917869

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 18 Feb 2020 12:51:24 +0000

python-escript (5.5-2) unstable; urgency=medium

  * Use dh-sequence-* instead of --with python3,sphinxdoc
  * Set -j1 on some archs to avoid out-of-memory/hangs
  * Use ${sphinxdoc:Depends} to add correct links.
    Closes: #945538, #877460

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 17 Feb 2020 11:11:06 +0000

python-escript (5.5-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.5.0
  * Patches to support  scons build files with python3

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 16 Feb 2020 11:10:18 +0000

python-escript (5.4-4) unstable; urgency=medium

  * Fix build issue on 32-bit systems: split debian/sid_options.py into
    mpi and non-mpi parts, settin werror=False

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 19 Dec 2019 08:45:32 +0000

python-escript (5.4-3) unstable; urgency=medium

  * Drop python-numpy build-depends. Closes: #937731
  * Standards-Version now 4.4.1.0
  * Build-Depend on trilinos-dev for 64-bit archs
  * Build-depend on gmsh
  * Drop -Wno-maybe-uninitialized and use -Wno-unitialized instead because of 
    warnings. Closes: #917689

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 16 Dec 2019 14:17:27 +0000

=== debian/control ===
Source: python-escript
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Joel Fenwick <j.oelpublic@gmail.com>,
 Alastair McKinstry <mckinstry@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               dh-sequence-python3,
               dh-sequence-sphinxdoc,
               python3-dev,
               python3-gdal,
               python3-sympy,
               python3-matplotlib,
               python3-numpy,
	       python3-scipy,
	       python3-pyproj,
               libboost-python-dev,
               libboost-random-dev,
               libnetcdf-dev,
               libnetcdf-cxx-legacy-dev,
	       libnetcdf-c++4-dev,
    	       libsilo-dev (>= 4.10.2.real-5),
               trilinos-dev [ amd64 arm64 ppc64el  s390x  ppc64],
               libtrilinos-amesos2-dev [ amd64 arm64 ppc64el  s390x  ppc64],
               gmsh,
	       mpi-default-dev,
               scons,
               zip,
               python3-sphinx,
               doxygen,
               texlive,
               ghostscript,
               texlive-latex-extra,
               texlive-latex-recommended,
               lsb-release,
               libopenmpi-dev,
               openmpi-bin,
               libjs-mathjax
Standards-Version: 4.5.0
Homepage: https://launchpad.net/escript-finley
Vcs-Browser: https://salsa.debian.org:/science-team/python-escript.git
Vcs-Git: https://salsa.debian.org:/science-team/python-escript.git

Package: python3-escript
Architecture: any
Section: python
Depends: ${python3:Depends},
         python3-numpy,
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: python3-sympy,
            python3-matplotlib,
            python3-scipy
Suggests: python3-pyproj,
          python3-gdal,
          python-escript-doc
Description: Escript/Finley finite elements Python3 system (with OpenMP)
 Escript is a programming tool for implementing mathematical models in Python
 using the finite element method (FEM). Because users do not access the data
 structures it is very easy to use and scripts can run on desktop computers as
 well as highly parallel supercomputer without changes. Application areas for
 escript include earth mantle convection, geophysical inversion, earthquakes,
 porous media flow, reactive transport, plate subduction, erosion, and 
 tsunamis.
 .
 Scripts can be executed in parallel (on varying numbers of threads or nodes)
 without any special modifications.  
 .
 Escript now includes the esys.downunder module for 3D inversion of geophysical
 data sets. The current version supports gravity, magnetic and joint inversion.
 .
 This package contains the commands and libraries for Python3 with 
 OpenMP threading and MPI multiprocess support. 

Package: python3-escript-mpi
Architecture: any
Section: python
Depends: ${python3:Depends},
         python3-numpy,
         openmpi-bin,
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: python3-sympy,
            python3-matplotlib,
            python3-scipy
Suggests: python3-pyproj,
          python3-gdal,
          python-escript-doc
Description: Escript/Finley finite elements Python3 system (OpenMP + MPI)
 Escript is a programming tool for implementing mathematical models in Python 
 using the finite element method (FEM). Because users do not access the data 
 structures it is very easy to use and scripts can run on desktop computers as 
 well as highly parallel supercomputer without changes. Application areas for 
 escript include earth mantle convection, geophysical inversion, earthquakes, 
 porous media flow, reactive transport, plate subduction, erosion, and 
 tsunamis.
 .
 Scripts can be executed in parallel (on varying numbers of threads or nodes) 
 without any special modifications.  
 .
 Escript now includes the esys.downunder module for 3D inversion of geophysical
 data sets. The current version supports gravity, magnetic and joint inversion.
 .
 This package contains the commands and libraries for Python3 with 
 both OpenMP threading and MPI multiprocess support.  

Package: python-escript-doc
Architecture: all
Section: doc
Depends: doc-base,
         libjs-sphinxdoc,
         libjs-mathjax,
         sphinx-common,
         ${misc:Depends},
	 ${sphinxdoc:Depends}
Recommends: python3-escript
Description: Documentation for Escript/Finley
 Escript is a programming tool for implementing mathematical models in Python 
 using the finite element method (FEM). Because users do not access the data 
 structures it is very easy to use and scripts can run on desktop computers as 
 well as highly parallel supercomputer without changes. Application areas for 
 escript include earth mantle convection, geophysical inversion, earthquakes, 
 porous media flow, reactive transport, plate subduction, erosion, and 
 tsunamis.
 .
 Scripts can be executed in parallel (on varying numbers of threads or nodes) 
 without any special modifications.  
 .
 Escript now includes the esys.downunder module for 3D inversion of geophysical
 data sets. The current version supports gravity, magnetic and joint inversion.
 .
 This package contains the documentation for escript, 
 including example scripts the user guide, the cookbook (an introduction from 
 a geoscientists point of view) and a guide to the esys.downunder inversion 
 toolkit.

=== debian/rules ===
#!/usr/bin/make -f

PROJROOT=$(CURDIR)
B3DEST=$(CURDIR)/debian/python3-escript
B3MDEST=$(CURDIR)/debian/python3-escript-mpi
DDEST=$(CURDIR)/debian/python-escript-doc
BUILD3=$(CURDIR)/debian/tmp3
BUILD3M=$(CURDIR)/debian/tmp3M
WORK3=$(CURDIR)/debian/stage3
WORK3M=$(CURDIR)/debian/stage3M

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

#export DEB_CXXFLAGS_MAINT_APPEND = -Wno-maybe-uninitialized
#export DEB_CFLAGS_MAINT_APPEND = -Wno-maybe-uninitialized
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-uninitialized
export DEB_CFLAGS_MAINT_APPEND = -Wno-uninitialized

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk


#thanks to the debian manual
# export DEB_BUILD_OPTIONS="parallel=10"
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    PARBUILD:=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    SFLAGS:=-j$(PARBUILD)
else
    SFLAGS:=-j1
endif

# Some archs have memory / speed issues See #917869
SMALL_ARCHS:= mips64el 
SFLAGS:= $(if $(filter $(DEB_TARGET_ARCH), $(SMALL_ARCHS)),-j1, $(SFLAGS) ) 
OPT:= $(if $(filter $(DEB_TARGET_ARCH), $(SMALL_ARCHS)),-O0 mxgot , -O3 ) 


%:
	dh $@  -v

override_dh_clean:
	find . -name '*.pyc' -delete 
	rm -f itest.sh utest.sh
	rm -rf build condif.log esys include lib release .sconf_tmp .sconsign.dblite config.log .sconf_temp
	rm -rf $(B3DEST)
	rm -rf $(B3MDEST)
	rm -rf $(DDEST)
	rm -rf $(BUILD3)
	rm -rf $(BUILD3M)
	rm -rf $(WORK3)
	rm -rf $(WORK3M)
	rm -rf $(CURDIR)/debian/tmp/*
	rm -f debian/files
	rm -f debian/substvars
	dh_clean

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.trivial

override_dh_dwz:
	@echo "Ignore DWZ errors"

override_dh_auto_build:
	# Build steps for py3
	mkdir -p $(WORK3)
	scons $(SFLAGS) cc_optim='$(OPT)'  build_dir=$(BUILD3) verbose=on prefix=$(WORK3) options_file=debian/sid_options.py docs
	# extract the relevant .py files
	cd $(WORK3); $(PROJROOT)/debian/utils/cppy.py $(PROJROOT); cd $(PROJROOT)
	cp $(PROJROOT)/doc/manpage/man1/run-escript.1 $(WORK3)/run-escript3.man
	ln $(WORK3)/bin/run-escript $(WORK3)/bin/run-escript3
	find $(WORK3) -name '*.pyc' -print0| xargs -0 rm -f

	mkdir -p $(BUILD3)
	scons $(SFLAGS) build_dir=$(BUILD3) verbose=on prefix=$(WORK3) options_file=debian/sid_options.py docs
	find $(WORK3) -name '*.pyc' -print0 | xargs -0 rm -f

	# Build steps for py3 with MPI
	mkdir -p $(WORK3M)
	scons $(sflags)  build_dir=$(BUILD3M)  cc_optim='$(OPT) -DOVERLORDPATH=\"/usr/lib/python-escript3-mpi/\"' \
		verbose=on prefix=$(WORK3M) options_file=debian/sid_options_mpi.py
	# extract the relevant .py files
	cd $(WORK3M); $(PROJROOT)/debian/utils/cppy.py $(PROJROOT); cd $(PROJROOT)
	cp $(PROJROOT)/doc/manpage/man1/run-escript.1 $(WORK3M)/run-escript3-mpi.man
	ln $(WORK3M)/bin/run-escript $(WORK3M)/bin/run-escript3-mpi
	find $(WORK3M) -name '*.pyc' -print0| xargs -0 rm -f	
	#rm -rf $(BUILD3M)	
	# fix paths in each package and
	# fix some external links in the doc package
	debian/utils/tweak.sh  "$(WORK3)" "$(WORK3M)"
	rm -f scons/templates/*.pyc
	rm -f site_scons/*.pyc
	rm -f utest.sh

override_dh_shlibdeps:
	# so libraries we just built are checked as well
	dh_shlibdeps -ppython3-escript  -Npython3-escript-mpi -Npython-escript-doc -P$(B3DEST) -l$(B3DEST)/usr/lib/python3-escript/lib
	dh_shlibdeps -ppython3-escript-mpi -Npython3-escript -Npython-escript-doc -P$(B3MDEST) -l$(B3MDEST)/usr/lib/python3-escript-mpi/lib

override_dh_python3:
	dh_python3 -ppython3-escript -Npython3-escript-mpi -Npython-escript-doc --no-ext-rename	usr/lib/python3-escript/esys
	dh_python3 -ppython3-escript-mpi -Npython3-escript -Npython-escript-doc --no-ext-rename	usr/lib/python3-escript-mpi/esys

=== debian/watch ===
version=3
https://launchpad.net/escript-finley/+download https://launchpad.net/escript-finley/3.0\+/.+/\+download/python-escript_(.+).tar.gz
